UIZero = {}
UIZero.ultralite = true;	-- this hides visible elements from the interface to improve performance.
							-- set to true or false
							-- Macro: /run UIZero.ultralite = false; /run UIZero.ultralite = true;

UIZero.onlymembers = true;	-- only members in your friend or guild list can whisper to you
							-- set to true or false (the message still appears in the chat window)

UIZero.hidechattabs = true;	-- set to true or false for hide chat tabs

UIZero.hideminimaprim = true;	-- set to true or false for Hide or Show Minimap Rim

UIZeroLocale = {}
local loc = UIZeroLocale;


UIZero.COLOR_CHANNEL= "|cff88ffff";
UIZero.COLOR_GUILD  = "|cff44ff44";
UIZero.COLOR_PARTY  = "|cff8888ff";
UIZero.COLOR_WHISPER ="|cffff88ff";
UIZero.COLOR_CHAT   = "|cffffffff";
UIZero.COLOR_EMOTE  = "|cff884488";
UIZero.COLOR_SAY    = "";


function UIZero.init()
    UIZero.minimapHiding = true;
    UIZero.lastTick = 0.0;
    UIZero.lastMessage = 0.0;
    UIZero.lastWarningText = "";
    UIZero.lastMessageText = "";
    UIZero_Frame:RegisterEvent("CHAT_MSG_GM");
    UIZero_Frame:RegisterEvent("CHAT_MSG_SAY");
    UIZero_Frame:RegisterEvent("CHAT_MSG_EMOTE");
    UIZero_Frame:RegisterEvent("CHAT_MSG_GUILD");
    UIZero_Frame:RegisterEvent("CHAT_MSG_PARTY");
    UIZero_Frame:RegisterEvent("CHAT_MSG_CHANNEL");
    UIZero_Frame:RegisterEvent("CHAT_MSG_GM_TALK");
    UIZero_Frame:RegisterEvent("CHAT_MSG_WHISPER");
	-- event that loot available for roll
    UIZero_Frame:RegisterEvent("LOOT_ITEM_SHOW");
    -- events that bring the interface back on.
    UIZero_Frame:RegisterEvent("MAIL_SHOW");
    UIZero_Frame:RegisterEvent("LOADING_END");
    UIZero_Frame:RegisterEvent("UNIT_TRADE_REQUEST");
    UIZero_Frame:RegisterEvent("UNIT_TARGET_CHANGED");
    UIZero_Frame:RegisterEvent("PARTY_INVITE_REQUEST");

	-- Clean Minimap
	if UIZero.hideminimaprim then
		MinimapRimFrame:Hide();
    else
		MinimapRimFrame:ClearAllAnchors();
		MinimapRimFrame:SetSize(180, 180);
		MinimapRimFrameTexture1:SetSize(180, 90);
		MinimapRimFrameTexture2:SetSize(180, 90);
		MinimapRimFrame:SetAnchor("CENTER", "CENTER", MinimapFrame, 0, 0);
		MinimapRimFrameTexture1:SetTexture("Interface/AddOns/UIZero/MinimapRim1");
		MinimapRimFrameTexture2:SetTexture("Interface/AddOns/UIZero/MinimapRim2");
    end
	MinimapFrame:SetSize(180, 180);
	MinimapViewFrame:SetSize(180, 180);
	MinimapViewFrame:ClearAllAnchors();
	MinimapFramePlusButton:SetScale(0.7);
	MinimapFrameMinusButton:SetScale(0.7);
	MinimapFramePlusButton:ClearAllAnchors();
	MinimapFrameMinusButton:ClearAllAnchors();
	MinimapViewFrame:SetAnchor("TOP", "TOP", MinimapFrame, 0, 0);
	MinimapFramePlusButton:SetAnchor("BOTTOMRIGHT","BOTTOMRIGHT",MinimapFrame,-5,-10);
	MinimapFrameMinusButton:SetAnchor("BOTTOMRIGHT","BOTTOMRIGHT",MinimapFrame,-28,-10);
	MINIMAPFRAME_MASK_NAME = "\\Interface\\AddOns\\UIZero\\MinimapMask.tga";
	OnLoad_Lua_Minimap(MinimapFrame);

    if not UIZero.ultralite then
        DEFAULT_CHAT_FRAME:AddMessage(loc.LOAD_MESSAGE);
    else
        DEFAULT_CHAT_FRAME:AddMessage(loc.LOAD_MESSAGE..loc.ULTRALITE_MSG);
    end
    
    SLASH_Minimap1 = "/minimap";
    SlashCmdList["Minimap"] = function(editBox, msg)
        if not msg or msg == "" then
            if UIZero.minimapHiding then
                msg = "off";
            else
                msg = "on";
            end
        end
        if msg == "on" or msg == "true" then
            UIZero.minimapHiding = true;
            UIZero.hideMinimap();
            DEFAULT_CHAT_FRAME:AddMessage(loc.MINIMAP_HIDING_ENABLED);
        elseif msg == "off" or msg == "false" then
            UIZero.minimapHiding = false;
            UIZero.showMinimap();
            DEFAULT_CHAT_FRAME:AddMessage(loc.MINIMAP_HIDING_DISABLED);
        end
    end

end;


function UIZero.HideUIFrames()
    -- code from hideui to produce a high-performance visible user interface.
    PlayerFrame:Hide();
    MainMenuFrame:Hide();
    ExperienceText:Hide();
    ExperienceFrame:Hide();
    ExperienceStatusBar:Hide();
    ExperienceHeadTexture:Hide();
    -- ExperienceText:Hide();
    -- ExperienceDebt:Hide();		--ExperienceDebt is very important, it stays.
    -- ExtraExperienceFrame:Hide();	-- these are important
    -- ExtraSkillPointFrame:Hide();
    
    --- code from nkchat to hide the tabs
	if UIZero.hidechattabs == true then
		local ChatFrameTab;
		for idx = 1, 10 do
			ChatFrameTab = getglobal ("ChatFrame" .. idx .. "Tab");
			ChatFrameTab:Hide();
		end
	end
end;


function UIZero.ShowUIFrames()
    -- code from hideui to produce a high-performance visible user interface.
    PlayerFrame:Show();
    MainMenuFrame:Show();
    ExperienceText:Show();
    ExperienceFrame:Show();
    ExperienceStatusBar:Show();
    ExperienceHeadTexture:Show();
    -- ExperienceText:Show();
    -- ExperienceDebt:Show();		-- ExperienceDebt is very important, it stays.
    -- ExtraExperienceFrame:Show();	-- these are important
    -- ExtraSkillPointFrame:Show();
    
    --- code from nkchat to Show the tabs
    local ChatFrameTab;
    for idx = 1, 10 do
	    ChatFrameTab = getglobal ("ChatFrame" .. idx .. "Tab");
	    ChatFrameTab:Show();
    end
end;


function UIZero.onUpdate(elapsedTime)
    UIZero.lastTick = UIZero.lastTick + elapsedTime;

    if UIZero.lastTick > 0.25 then
        UIZero.lastTick = 0.0;
        UIZero.setWarning( UIZero.warnings() );
        
        if not UIParent:IsVisible() then
            -- ui off: show when opening a panel
        
            if ChatFrameEditBox:IsVisible() or BagFrame:IsVisible() or CharacterFrame:IsVisible() 
            or GuildFrame:IsVisible() or WorldMapFrame:IsVisible() or UI_SkillBook:IsVisible() then
                -- show the ui again to see the panels...
                -- TODO: Quest, Map, World Search
                UIParent:Show();
                UIZero.setMessage("");
            end
        elseif UIZero.ultralite then 
            -- ui on and ultralite mode activated.
            
            -- autohide the bottom action bar along with inventory or skill book
            if MainActionBarFrame:IsVisible() then
                if not BagFrame:IsVisible() and not UI_SkillBook:IsVisible() then
                    UIZero.mainBar  = MainActionBarFrame:IsVisible();   if UIZero.mainBar   then MainActionBarFrame:Hide(); end;
                    UIZero.leftBar  = LeftActionBarFrame:IsVisible();   if UIZero.leftBar   then LeftActionBarFrame:Hide(); end;
                    UIZero.rightBar = RightActionBarFrame:IsVisible();  if UIZero.rightBar  then RightActionBarFrame:Hide(); end;
                    UIZero.bottomBar= BottomActionBarFrame:IsVisible(); if UIZero.bottomBar then BottomActionBarFrame:Hide(); end;
                    UIZero.hideMinimap();
                end
            else
                if BagFrame:IsVisible() or UI_SkillBook:IsVisible() then
                    if UIZero.mainBar   then MainActionBarFrame:Show(); end;
                    if UIZero.leftBar   then LeftActionBarFrame:Show(); end;
                    if UIZero.rightBar  then RightActionBarFrame:Show(); end;
                    if UIZero.bottomBar then BottomActionBarFrame:Show(); end;
                    UIZero.showMinimap();
                end
            end
            
            -- experience stuff and bars are visible along with the CharacterFrame
            if PlayerFrame:IsVisible() then
                -- show experience and details
                if not CharacterFrame:IsVisible() then
                    PlayerFrame:Hide();		--autohides
                    MainMenuFrame:Hide();
                    ExperienceFrame:Hide();
					PetBookFrameButton:Hide();
                    ExperienceStatusBar:Hide();
					PlayerFramePetButton:Hide();
                    ExperienceHeadTexture:Hide();
					PlayerFramePartyBoardButton:Hide();
                    -- ExperienceDebt:Hide();
                    -- ExperienceText:Hide();
                    -- ExtraExperienceFrame:Hide();
                    -- ExtraSkillPointFrame:Hide();
                end
            else
                if CharacterFrame:IsVisible() then
                    PlayerFrame:Show();		--autoshows
                    MainMenuFrame:Show();
                    ExperienceFrame:Show();
					PetBookFrameButton:Show();
                    ExperienceStatusBar:Show();
					PlayerFramePetButton:Show();
                    ExperienceHeadTexture:Show();
					PlayerFramePartyBoardButton:Show();
                    -- ExperienceDebt:Show();
                    -- ExperienceText:Show();
                    -- ExtraExperienceFrame:Show();
                    -- ExtraSkillPointFrame:Show();
                end
            end
            
            -- CtrlKey shows minimap, buffs, party and chat
            if IsCtrlKeyDown() or ChatFrameEditBox:IsVisible() then
                if not DEFAULT_CHAT_FRAME:IsVisible() then
                    PlayerBuffFrame:Show();
                    DEFAULT_CHAT_FRAME:Show();
                    -- QuestTrackFrame:Show();
                    if not BagFrame:IsVisible() then
                        UIZero.showMinimap();
                    end
                end
            else
                if DEFAULT_CHAT_FRAME:IsVisible() then
                    PlayerBuffFrame:Hide();
                    DEFAULT_CHAT_FRAME:Hide();
                    -- QuestTrackFrame:Hide();
                    if not BagFrame:IsVisible() then
                        UIZero.hideMinimap();
                    end
                end
            end
        end
        
    end

    -- hide old messages
    if UIZero.lastMessage > 0.0 then
        UIZero.lastMessage = UIZero.lastMessage + elapsedTime;
        if UIZero.lastMessage > 6.0 then
            UIZero.setMessage("");
        end
    end
end;


function UIZero.showMinimap()
    if UIZero.minimapHiding then
        MinimapFrame:Show();
        MinimapNpcTrackButton:Show();
        MinimapFrameStoreButton:Show();
        MinimapFrameOptionButton:Show();
        MinimapBeautyStudioButton:Show();
        MinimapFrameBulletinButton:Show();
        MinimapFrameRestoreUIButton:Show();
        MinimapFrameQuestTrackButton:Show();
        MinimapFrameBattleGroundButton:Show();
    end
end;


function UIZero.hideMinimap()
    if UIZero.minimapHiding then
        MinimapFrame:Hide();
        MinimapNpcTrackButton:Hide();
        MinimapFrameStoreButton:Hide();
        MinimapFrameOptionButton:Hide();
        MinimapBeautyStudioButton:Hide();
        MinimapFrameBulletinButton:Hide();
        MinimapFrameRestoreUIButton:Hide();
        MinimapFrameQuestTrackButton:Hide();
        MinimapFrameBattleGroundButton:Hide();
    end
end;


function UIZero.onEvent(event, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9)
    -- show chat or drop roll only the whole interface is hidden.
    if not DEFAULT_CHAT_FRAME:IsVisible() or not UIParent:IsVisible() then
        if string.find(event, "CHAT_", 1, true) then

            if arg1 == nil then arg1 = "" end;
            local color = "testing: ";
            if event == "CHAT_MSG_CHANNEL" then
                color = UIZero.COLOR_CHANNEL;
            elseif event == "CHAT_MSG_GUILD" then
                color = UIZero.COLOR_GUILD;
            elseif event == "CHAT_MSG_PARTY" then
                color = UIZero.COLOR_PARTY;
            elseif event == "CHAT_MSG_WHISPER" then
                -- only members in your friend or guild list can whisper to you (the message still appears in the chat window)
                if UIZero.onlymembers == false or UIZero.isFriend(arg2) or UIZero.isGuildMember(arg2) then
                    color = UIZero.COLOR_WHISPER;
                else
                    return;
                end
            elseif event == "CHAT_MSG_EMOTE" then
                color = UIZero.COLOR_EMOTE;
            elseif event == "CHAT_MSG_SAY" then
                color = UIZero.COLOR_SAY;
            else
                color = "|cffff4444"; --gm?
            end

            if arg2 == nil then
                arg2 = "";
            elseif arg2 ~= "" then 
                arg2 = arg2.." ";
            end
            if arg1 == nil then
                arg1 = "";
            end
            --elseif #arg1 > 50 then --truncates links
            --    arg1 = string.sub(arg1, 1, 50).."...";
            --end

            UIZero.setMessage( color..arg2..arg1 );
            return;
        elseif event == "LOOT_ITEM_SHOW" then
            -- loot available
            if arg1 == nil then
                arg1 = "...";
            end
            UIZero.setMessage( loc.LOOT );
            return;
        elseif event == "UNIT_TARGET_CHANGED" then
            -- clicked on an npc, show the interface so you can talk
            if (arg1 == "player" and UnitLevel("target") ~= nil 
				and not UnitIsPlayer("target") and not UnitCanAttack("player", "target")) then
                UIParent:Show();
            end
            return;
        else
            -- mailbox, receive party invitations...
            UIParent:Show();
        end
    end
    if event == "LOADING_END" then
        if UIZero.ultralite then
            UIZero.HideUIFrames();		-- doesn't hide the tabs here...
			if BagFrame:IsVisible() then
                BagFrame:Hide();
            end
        else
            UIZero.ShowUIFrames();
        end
    end
end;


function UIZero.warnings()
    -- update warnings section
    local msg = "";
    local life = UnitHealth("player")/UnitMaxHealth("player");
    if life > 0.0 then

        -- are you hurt?
        if life < 0.3 then
            msg = msg..loc.PLAYER_LIFE_3;
        elseif life < 0.525 then
            msg = msg..loc.PLAYER_LIFE_2;
        elseif life < 0.75 then
            msg = msg..loc.PLAYER_LIFE_1;
        end

        -- are you low on mana?
        local mana = UnitMana("player")/UnitMaxMana("player");
        local manaType = UnitManaType("player");
        if mana < 0.75 then
            msg = msg..loc.MANA_TYPES[manaType]
            if mana < 0.525 then
                msg = msg.."!";
                if mana < 0.3 then
                    msg = msg.."!";
                end
            end
            msg = msg.." ";
        end
        
        -- lag?
        local ping = GetPing();
        if ping > 1200 then
            msg = msg.."|cffffffffLaaag!! ";
        elseif ping > 800 then
            msg = msg.."|cffffffffLaag! ";
        elseif ping > 400 then
            msg = msg.."|cffffffffLag.. ";
        end

        -- is someone on your party needing help?
        local pms = GetNumPartyMembers();
        if pms > 1 then
            for i = 2, pms do
                life = UnitMaxHealth("party"..(i-1));
                if life > 0 then
                    life = UnitHealth("party"..(i-1))/life;
                    if life > 0.0 then
                        --if ally is hurt, the F# key to select him, his name and ! or !! depending on how damaged is he
                        if life < 0.3 then
                            msg = msg.."|cffff0000F"..i..":"..GetPartyMember(i-1).."!! ";
                        elseif life < 0.525 then
                            msg =  msg.."|cffff4444F"..i..":"..GetPartyMember(i-1).."! ";
                        elseif life < 0.75 then
                            msg = msg.."|cffff8888F"..i..":"..GetPartyMember(i-1).." ";
                        elseif life == 0.0 then
                            msg = msg.."|cff666666F"..i..":"..GetPartyMember(i-1)..". "; --dead
                        end
                    end
                end
            end
        end
    end

    return msg;
end;


function UIZero.isFriend(name) 
    local friend;
    for i = 1, GetFriendCount("Friend") do
        friend = GetFriendInfo("Friend", i)
        if name == friend then
            return true;
        end
    end
    return false;
end;


function UIZero.isGuildMember(name)
    local mate;
    for i = 1, GetNumGuildMembers() do
        mate = GetGuildRosterInfo(i);
        if name == mate then
            return true;
        end
    end
    return false;
end;


-- utils to prevent the UI from being rerendered, this saves some fps

function UIZero.setWarning(msg)
    if UIZero.lastWarningText ~= msg then
        UIZero_Warnings_Text:SetText( msg );
        UIZero.lastWarningText = msg;
    end
end;


function UIZero.setMessage(msg)
    if UIZero.lastMessageText ~= msg then
        UIZero_Messages_Text:SetText( msg );
        UIZero.lastMessageText = msg;
        if msg ~= "" then
            UIZero.lastMessage = 0.001;
        else
            UIZero.lastMessage = 0.0;
        end
    end
end;

